package remote_http

import (
	"context"
	"errors"
	"fmt"
	"mylomen_server/common/dto"
	"mylomen_server/common/utils"
)

type aiRouterImpl struct {
}

func (aiRouterImpl) Completions(ctx context.Context, prompt, groupId string) (*dto.AiRes, error) {
	logger := utils.NewLog("")

	url := "https://openrouter.ai/api/v1/chat/completions"

	var aiResult Result[dto.AiRes]

	var result RouterResultVO
	//const body = JSON.stringify({model: "google/gemma-7b-it:free", "stream": false, messages: messages});
	resp, err := httpClient.R().
		SetBody(map[string]interface{}{
			"model":    "google/gemma-7b-it:free",
			"stream":   false,
			"messages": []map[string]interface{}{{"role": "user", "content": prompt}},
		}).SetHeaders(map[string]string{
		"Content-Type":  "application/json",
		"Authorization": "Bearer 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",
	}).
		SetSuccessResult(&result).
		Post(url)
	if err != nil {
		logger.Error(fmt.Sprintf("remote_http_wx_SendMsg error: %s", err.Error()))
		return nil, err
	}

	if !resp.IsSuccessState() {
		logger.Error(fmt.Sprintf("remote_http_wx_SendMsg resp:%+v", resp))
		return nil, errors.New("接口异常")
	}

	aiResult.Data.Completions = result.Choices[0].Message.Content

	return &aiResult.Data, nil
}

type RouterResultVO struct {
	Id      string `json:"id"`
	Model   string `json:"model"`
	Object  string `json:"object"`
	Created int    `json:"created"`
	Choices []struct {
		Index   int `json:"index"`
		Message struct {
			Role    string `json:"role"`
			Content string `json:"content"`
		} `json:"message"`
		FinishReason string `json:"finish_reason"`
	} `json:"choices"`
	Usage struct {
		PromptTokens     int `json:"prompt_tokens"`
		CompletionTokens int `json:"completion_tokens"`
		TotalTokens      int `json:"total_tokens"`
	} `json:"usage"`
}
